/******************************************************************************
 *	VRAM / TEXT ́AO`悩XVꂽA`
 *****************************************************************************/

#define	VRAM2SCREEN_DIFF( vram2screen_diff_function )			      \
int	vram2screen_diff_function( void )				      \
{									      \
  int	x0 = COLUMNS-1, x1 = 0, y0 = ROWS-1, y1 = 0;			      \
  int	i, j, k;							      \
  int	changed_line;		/* XV郉Crbg(0`COLUMN)ŕ\ */ \
									      \
  unsigned short text, *text_attr= &text_attr_buf[ text_attr_flipflop   ][0]; \
  unsigned short old,  *old_attr = &text_attr_buf[ text_attr_flipflop^1 ][0]; \
  T_GRYPH fnt;				/* tHg̎` 1   */	      \
  int	fnt_idx;			/* tHg̎` Qƈʒu  */	      \
  bit8	style = 0;			/* tHg̎` 8hbg */	      \
  int	tpal;				/* tHg̐FR[h       */	      \
  int	tcol;				/* tHg̐F             */	      \
									      \
  char	*up = &screen_update[0];	/* VRAMXVtOւ̃|C^ */      \
  bit32	*src  = main_vram4;		/* VRAMւ̃|C^           */      \
  DST_DEFINE()				/* `GAւ̃|C^     */      \
  WORK_DEFINE()				/* ɕKvȃ[N         */      \
									      \
									      \
  for( i=0; i<ROWS; i++ ){  /*=============================================*/ \
					/* 1Pʂŕ`悵Ă̂ŁA   */ \
					/*  (s~) A[v*/ \
				/*-----------------------------------------*/ \
    for( j=0; j<COLUMNS; j+=COLUMN_SKIP ){	/* 40Ȃ2ɏ   */ \
									      \
      text = *text_attr;  text_attr += COLUMN_SKIP;	/* eLXgR[h */  \
      old  = *old_attr;   old_attr  += COLUMN_SKIP;	/* E擾   */  \
									      \
      if( text != old ){			/* eLXgVsv ?    */ \
	changed_line = ~(0);			    /* yes 1XV */ \
      }									      \
      else{					    /* no XV`FbN */ \
	changed_line = 0;						      \
	for( k=0; k<CHARA_LINES; k++ ){					      \
	  if( up[ k*80 ] || 						      \
	      up[ k*80 + (COLUMN_SKIP-1) ] ){ changed_line |= (1<<k); }	      \
	}								      \
      }									      \
									      \
      if( changed_line ){	    /* ꂩ̃C`悷ꍇ      */ \
        if(i<y0) y0=i;  if(i>y1) y1=i;  if(j<x0) x0=j;  if(j>x1) x1=j;	      \
									      \
	get_font_gryph( text, &fnt, &tpal );	/* tHǧ`擾      */ \
	tcol = COLOR_PIXEL( tpal );					      \
	fnt_idx = 0;							      \
					/*-------------------------------*/   \
	for( k=0; k<CHARA_LINES; k++ ){	    /* ̃C[v*/   \
									      \
	  IF_LINE200_OR_EVEN_LINE()	    /* 200line400lineŋline*/   \
	    style = fnt.b[ fnt_idx++ ];	    /* ̎,tHg8hbg擾*/   \
									      \
	  if( changed_line & (1<<k) ){	    /* ̃C`悷ꍇ*/     \
									      \
	    if      ( style==0xff ){		/* TEXT ݂̂`   */     \
	      MASK_DOT();			/*                     */     \
	    }else if( style==0x00 ){		/* VRAM ݂̂`   */     \
	      TRANS_DOT();			/*                     */     \
	    }else{				/* TEXT/VRAM`   */     \
	      STORE_DOT();			/*                     */     \
	    }					/*                     */     \
	    COPY_DOT();				/* C Ԗ   */     \
	  }				    /*                         */     \
									      \
	  DST_NEXT_LINE();		    /* ̃Cʒuɐi      */   \
	}				/*-------------------------------*/   \
									      \
	DST_RESTORE_LINE();		/* C擪ɖ߂                */ \
      }				    /*                                     */ \
									      \
									      \
      up  += COLUMN_SKIP;						      \
      src += COLUMN_SKIP;						      \
      DST_NEXT_CHARA();			/* ̕ʒuɐi              */ \
    }				/*-----------------------------------------*/ \
									      \
    up  += (CHARA_LINES-1)* 80;						      \
    src += (CHARA_LINES-1)* 80;						      \
    DST_NEXT_TOP_CHARA();		/* ̍s̐擪ʒuɐi      */ \
  }                         /*=============================================*/ \
									      \
  if( x0 <= x1 ){							      \
    return ( ((x0            )<<24) | (((y0  )*(200/ROWS))<<16) |	      \
             ((x1+COLUMN_SKIP)<< 8) | (((y1+1)*(200/ROWS))    ) );	      \
  }else{								      \
    return -1;								      \
  }									      \
}



/******************************************************************************
 *	VRAM / TEXT ̑SʕA`
 *****************************************************************************/

#define	VRAM2SCREEN_ALL( vram2screen_all_function )			      \
int	vram2screen_all_function( void )				      \
{									      \
									      \
  int	i, j, k;							      \
									      \
									      \
  unsigned short text, *text_attr= &text_attr_buf[ text_attr_flipflop   ][0]; \
									      \
  T_GRYPH fnt;				/* tHg̎` 1   */	      \
  int	fnt_idx;			/* tHg̎` Qƈʒu  */	      \
  bit8	style = 0;			/* tHg̎` 8hbg */	      \
  int	tpal;				/* tHg̐FR[h       */	      \
  int	tcol;				/* tHg̐F             */	      \
									      \
									      \
  bit32	*src  = main_vram4;		/* VRAMւ̃|C^           */      \
  DST_DEFINE()				/* `GAւ̃|C^     */      \
  WORK_DEFINE()				/* ɕKvȃ[N         */      \
									      \
									      \
  for( i=0; i<ROWS; i++ ){  /*=============================================*/ \
					/* 1Pʂŕ`悵Ă̂ŁA   */ \
					/*  (s~) A[v*/ \
				/*-----------------------------------------*/ \
    for( j=0; j<COLUMNS; j+=COLUMN_SKIP ){	/* 40Ȃ2ɏ   */ \
									      \
      text = *text_attr;  text_attr += COLUMN_SKIP;	/* eLXgR[h */  \
									      \
									      \
									      \
									      \
									      \
									      \
									      \
									      \
									      \
									      \
									      \
									      \
									      \
      {				    /* 1Pʂŕ`悵Ă             */ \
									      \
									      \
	get_font_gryph( text, &fnt, &tpal );	/* tHǧ`擾      */ \
	tcol = COLOR_PIXEL( tpal );					      \
	fnt_idx = 0;							      \
					/*-------------------------------*/   \
	for( k=0; k<CHARA_LINES; k++ ){	    /* ̃C[v*/   \
									      \
	  IF_LINE200_OR_EVEN_LINE()	    /* 200line400lineŋline*/   \
	    style = fnt.b[ fnt_idx++ ];	    /* ̎,tHg8hbg擾*/   \
									      \
	  {				    /* CPʂŕ`        */     \
									      \
	    if      ( style==0xff ){		/* TEXT ݂̂`   */     \
	      MASK_DOT();			/*                     */     \
	    }else if( style==0x00 ){		/* VRAM ݂̂`   */     \
	      TRANS_DOT();			/*                     */     \
	    }else{				/* TEXT/VRAM`   */     \
	      STORE_DOT();			/*                     */     \
	    }					/*                     */     \
	    COPY_DOT();				/* C Ԗ   */     \
	  }				    /*                         */     \
									      \
	  DST_NEXT_LINE();		    /* ̃Cʒuɐi      */   \
	}				/*-------------------------------*/   \
									      \
	DST_RESTORE_LINE();		/* C擪ɖ߂                */ \
      }				    /*                                     */ \
									      \
									      \
									      \
      src += COLUMN_SKIP;						      \
      DST_NEXT_CHARA();			/* ̕ʒuɐi              */ \
    }				/*-----------------------------------------*/ \
									      \
									      \
    src += (CHARA_LINES-1)* 80;						      \
    DST_NEXT_TOP_CHARA();		/* ̍s̐擪ʒuɐi      */ \
  }                         /*=============================================*/ \
									      \
									      \
  return ( ((0)<<24) | ((0)<<16) | ((COLUMNS)<<8) | (200) );		      \
}
