/************************************************************************/
/*									*/
/* EGCgp֐ (OSˑ)						*/
/*									*/
/* y֐z								*/
/*									*/
/* int  wait_vsync_init( void )		 (NɌĂяo)	*/
/* void wait_vsync_term( void )		I   (IɌĂяo)	*/
/*									*/
/* void	wait_vsync_reset( void )	vZbg (ݒύX)	*/
/* void wait_vsync( void )		EFCg (ݒԊuoߑ҂)	*/
/*									*/
/* void wait_menu( void )		j[pEFCg(1/60sec҂)	*/
/*									*/
/************************************************************************/
#include <stdio.h>

#include <SDL.h>

#include "quasi88.h"
#include "initval.h"
#include "wait.h"
#include "suspend.h"

#include "screen.h"	/* auto_skip... */



/*
 * t[XLbv		( by floi, thanks ! )
 */

static	int	skip_counter = 0;		/* AXLbv */
static	int	skip_count_max = 15;		/* ȏAXLbv
						   UAIɕ`悷 */


/*
 * EFCg֐Q
 */

static	int	wait_counter = 0;		/* A񎞊ԃI[o[*/
static	int	wait_count_max = 10;		/* ȏAI[o[
						   U, */

/* ́AusPʂōsȂBłϐ̌^ long Ȃ̂ 4295 bŒl
   ߂(wrap)܂A̎ 1t[̓^C~OB
   Ȃ̂ŁA\Ȃ 64bit^(long long)ɂĂ݂悤B */

#ifdef SDL_HAS_64BIT_TYPE
typedef	Sint64		T_WAIT_TICK;
#else
typedef	long		T_WAIT_TICK;
#endif

static	T_WAIT_TICK	next_time;		/* t[̎ */
static	T_WAIT_TICK	delta_time;		/* 1 t[̎ */



/* ---- ݎ擾 (usecP) ---- */

#define	GET_TICK()	( (T_WAIT_TICK)SDL_GetTicks() * 1000 )





/****************************************************************************
 * EFCg
 *****************************************************************************/
int	wait_vsync_init( void )
{
  if( ! SDL_WasInit( SDL_INIT_TIMER ) ){
    if( SDL_InitSubSystem( SDL_INIT_TIMER ) != 0 ){
      if( verbose_wait ) printf( "Error Wait (SDL)\n" );
      return FALSE;
    }
  }

  wait_vsync_reset();
  return TRUE;
}



/****************************************************************************
 * EFCgI
 *****************************************************************************/
void	wait_vsync_term( void )
{
}



/****************************************************************************
 * EFCgď
 *****************************************************************************/
void	wait_vsync_reset( void )
{
  wait_counter = 0;

  delta_time = (T_WAIT_TICK)(1000000.0/( CONST_VSYNC_FREQ * wait_rate / 100 ));
  next_time  = GET_TICK() + delta_time;

  /* delta_time >= 1000000us (1sec) ɂȂƁAƂ܂ */
}



/****************************************************************************
 * EFCg
 *****************************************************************************/
void	wait_vsync( void )
{
  int	on_time = FALSE;
  int	slept   = FALSE;
  T_WAIT_TICK	diff_ms;


  diff_ms = ( next_time - GET_TICK() ) / 1000;

  if( diff_ms > 0 ){	    /* ܂Ԃ]ĂȂ */
			    /* diff_ms ~bAEFCg */

    if( wait_by_sleep ){	/* Ԃ܂ sleep ꍇ */

#if 1	/* @ 1) */
      SDL_Delay( diff_ms );		/* diff_ms ~bAfBC   */
      slept = TRUE;

#else	/* @ 2) */
      if( diff_ms < 10 ){		/* 10msȂrW[EFCg */
	while( GET_TICK() <= next_time )
	  ;
      }else{				/* 10msȏȂfBC       */
	SDL_Delay( diff_ms );
	slept = TRUE;
      }
#endif

    }else{			/* Ԃ܂ Tick Ďꍇ */

      while( GET_TICK() <= next_time )
	;
    }

    on_time = TRUE;
  }


  if( slept == FALSE ){		/* x SDL_Delay Ȃꍇ */
    SDL_Delay( 1 );				/* for AUDIO thread ?? */
  }


  next_time += delta_time;


  if( on_time ){			/* ԓɏł */
    wait_counter = 0;
  }else{				/* ԓɏłĂȂ */
    wait_counter ++;
    if( wait_counter >= wait_count_max ){	/* xꂪЂǂꍇ */
      wait_vsync_reset();			/* EFCg   */
    }
  }



  /*
   * t[XLbv		( by floi, thanks ! )
   */
  if( use_auto_skip ){
    if( on_time ){			/* ԓɏł */
      skip_counter = 0;
      do_skip_draw = FALSE;
      if( already_skip_draw ){		/* ɕ`XLbvĂ */
	already_skip_draw = FALSE;
	reset_frame_counter();		/* ͕K`悷 */
      }
    }else{				/* ԓɏłĂȂ */
      skip_counter++;
      if( skip_counter >= skip_count_max ){	/* XLbv */
	skip_counter = 0;
	do_skip_draw = FALSE;
	already_skip_draw = FALSE;
	reset_frame_counter();			/* ͕K`悷 */
      }else{
	do_skip_draw = TRUE;			/* `XLbvKvL*/
      }
    }
  }

  return;
}



/****************************************************************************
 * j[p̃EFCg
 *	 1/60 bقǑ҂Bx͕svA\ȂK sleep ׂ
 *****************************************************************************/
void	wait_menu( void )
{
  SDL_Delay( 20 );
}
